blocks/urls.py
"""coding=utf-8"""
from django.urls import path
from . import views

# 正在部署的应用的名称
app_name = 'blocks'

urlpatterns = [
    path('blocks-list/<int:targetnum>', views.blocks_list, name='blocks_list'),
]

post/article/urls.py
from django.urls import path
from . import views

app_name = 'article'

urlpatterns = [
    path('article-detail/<int:id>/', views.article_detail, name='article_detail'),
    path('article-create/', views.article_create, name='article_create'),
    path('article-update/<int:id>/', views.article_update, name='article_update'),
    path('article-delete/<int:id>/', views.article_delete, name='article_delete'),
    path('article-download/<int:id>', views.download_file, name='download_file'),
]

post/question/urls.py
from django.urls import path
from . import views

app_name = 'question'

urlpatterns = [
    # 文章详情
    path('question-detail/<int:id>/', views.question_detail, name='question_detail'),
    path('question-create/', views.question_create, name='question_create'),
    path('question-update/<int:id>/', views.question_update, name='question_update'),
    path('question-delete/<int:id>/', views.question_delete, name='question_delete'),
    path('question-download/<int:id>', views.download_file, name='download_file'),
]

sailing/urls.py
from django.contrib import admin
from django.urls import path, include
from django.shortcuts import render
from post.article import views as article_views
from post.question import views as question_views
from user.userprofile import views as user_views

from django.conf import settings
from django.conf.urls.static import static
import notifications.urls
def mainPage(request):
    return render(request, 'user/collection.html', {})


def sort_column(column_questions, column_articles):
    column_content = []

    for question in column_questions:
        content = {'title': question.title, 'id': question.id, 'column': str(question.column), 'updated': question.updated, 'type': 'question'}
        column_content.append(content)
        pass

    for article in column_articles:
        content = {'title': article.title, 'id': article.id, 'column': str(article.column), 'updated': article.updated, 'type': 'article'}
        column_content.append(content)
        pass

    column_content = sorted(column_content, key=lambda x:(x['column'], x['updated']), reverse = True)
    
    #for item in column_content:
    #    if item['column'] != 'None':
    #        print(item)
    return column_content

def hot_content(request):
    # hotContent
    hot_questions = question_views.hot_question_list(request)
    hot_articles = article_views.hot_article_list(request)
    # blockContent
    column_questions = question_views.column_question_list()
    column_articles = article_views.column_article_list()
    column_content = sort_column(column_questions["column_questions"], column_articles["column_articles"])
    column_content = {'column_content': column_content}

    context = {**hot_questions, **hot_articles, **column_content}
    return render(request, 'mainPage.html', context)

urlpatterns = [
    path('admin/', admin.site.urls),
    path('userprofile/', include('user.userprofile.urls', namespace='userprofile')),
    path('article/', include('post.article.urls', namespace='article')),
    path('question/', include('post.question.urls', namespace='question')),
    path('comment/', include('reply.comment.urls', namespace='comment')),
    path('answer/', include('reply.answer.urls', namespace='answer')),
    path('like/', include('record.like.urls', namespace='like')),
    path('', hot_content, name='hot_content'),
    path('collect/', include('record.collect.urls', namespace='collect')),
    path('search_question/', question_views.search_question),
    path('search_article/', article_views.search_article),
    path('search_user/', user_views.search_user),
    path('blocks/',include('blocks.urls', namespace='blocks')),
    path('inbox/notifications/', include(notifications.urls, namespace='notifications')),
    path('notice/', include('user.notice.urls', namespace='notice')),
    # path('', mainPage)
]

urlpatterns += static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

user/notice/urls.py
from django.urls import path
from . import views

app_name = 'notice'

urlpatterns = [
    # 通知列表
    path('list/', views.CommentNoticeListView.as_view(), name='list'),
    # 更新通知状态
    path('update/', views.CommentNoticeUpdateView.as_view(), name='update'),
]

user/userprofile/urls.py
from django.urls import path
from . import views

app_name = 'userprofile'

urlpatterns = [
    # 用户登入
    path('login/', views.UserLogin.as_view(), name='login'),
    # 用户退出
    path('logout/', views.user_logout, name='logout'),
    # 用户退出
    path('register/', views.UserRegister.as_view(), name='register'),
    # 用户删除
    path('delete/<int:id>/', views.user_delete, name='delete'),
    # 用户安全删除
    path('safe-delete/<int:id>/', views.user_safe_delete, name='safe_delete'),
    # 用户查看信息
    path('profile/<int:id>/', views.profile, name='profile'),
    # 用户编辑信息
    path('profile-update/<int:id>/', views.ProfileUpdate.as_view(), name='profile_update'),
    # 用户修改密码
    path('password-update/<int:id>/', views.PasswordUpdate.as_view(), name='password_update'),
    # 用户查看点赞信息
    path('collect-record/<int:id>/', views.get_collect_record, name='get_collect_record'),
    # 用户封禁
    path('user-forbidden/<int:id>/', views.user_forbidden, name='user_forbidden'),
    # 查看用户发表的东西
    path('user-get_myob/<int:id>/', views.get_myob, name='user_get_myob'),
]

user/userprofile/models.py
from django.db import models
from django.contrib.auth.models import User


class Profile(models.Model):
    """
    用户信息类
    每个用户都与django自带的基本用户信息有级联关系
    """
    # 与 User 模型构成一对一的关系
    user = models.OneToOneField(User, on_delete=models.CASCADE, related_name='profile')
    # 电话号码字段
    phone = models.CharField(max_length=20, blank=True)
    # 头像
    avatar = models.ImageField(upload_to='avatar/%Y%m%d/', blank=True)
    # 个人简介
    bio = models.TextField(max_length=500, blank=True)
    # 邮箱
    email = models.CharField(max_length=20, blank=True)

    def __str__(self):
        return 'user {}'.format(self.user.username)

user/notice/views.py
# Create your views here.
from django.shortcuts import redirect
from django.views import View
from django.views.generic import ListView
from django.contrib.auth.mixins import LoginRequiredMixin
from post.article.models import ArticlePost
from post.question.models import QuestionPost


class CommentNoticeListView(LoginRequiredMixin, ListView):
    """
    通知列表类
    每个用户对每个文章/问题/回答评论，都会实例化；
    """
    # 上下文的名称
    context_object_name = 'notices'
    # 模板位置
    template_name = 'notice/list.html'
    # 登录重定向
    login_url = '/userprofile/login/'

    # 未读通知的查询集
    def get_queryset(self):
        return self.request.user.notifications.unread()


class CommentNoticeUpdateView(View):
    """更新通知状态类"""

    # 处理 get 请求
    def get(self, request):
        # 获取未读消息
        notice_id = request.GET.get('notice_id')
        verb = request.GET.get('verb')
        # 更新单条通知
        if notice_id:
            if verb == '评论了你':
                content = ArticlePost.objects.get(id=request.GET.get('id'))
            else:
                content = QuestionPost.objects.get(id=request.GET.get('id'))
            request.user.notifications.get(id=notice_id).mark_as_read()
            return redirect(content)
        # 更新全部通知
        else:
            request.user.notifications.mark_all_as_read()
            return redirect('notice:list')

user/userprofile/views.py
from django.contrib.auth.mixins import LoginRequiredMixin
from django.shortcuts import render, redirect, get_object_or_404
from django.contrib.auth import authenticate, login, logout
from django.http import HttpResponse
from django.contrib.auth.decorators import login_required
from django.contrib import messages
from django.db.models import Q
from django.contrib.auth.hashers import check_password
from .models import Profile
from .forms import UserLoginForm, UserRegisterForm, UserProfileForm, UserPasswordForm
from record.collect.models import CollectRecord
from post.article.models import ArticlePost
from post.question.models import QuestionPost
# 引入分页模块
from django.core.paginator import Paginator
# 引入权限检查模块
from django.contrib.auth.models import User
from django.contrib.auth.models import Permission
from django.views.generic.base import TemplateView


class Content:
    """一般常量类"""

    def __init__(self):
        pass

    is_need_message = 1
    not_need_message = 2
    is_dangerous_message = 3
    is_login = 1
    is_register = 2
    login_error_message = "账号或密码输入不合法"
    danger_message = "请使用GET或POST请求数据"
    register_error_message = "注册表单有误，请重新输入~"
    update_error_message = "你没有权限修改此用户信息。"
    del_warn_message = "你没有删除操作的权限。"
    method_post = 'POST'
    method_get = 'GET'
    db_user_name = 'username'
    password_form = 'user_password_form'
    profile = 'profile'
    user = 'user'
    profile_form = 'profile_form'
    id = 'id'
    phone = 'phone'
    bio = 'bio'
    email = 'email'
    avatar = 'avatar'
    user_profile = "userprofile:profile"


class PasswordContent:
    """密码相关常量类"""

    def __init__(self):
        pass

    password_error_message = "原始密码输入错误！"
    password_different_message = "两次新密码输入不同！"
    password_success_message = "修改密码成功！"
    old_password = 'old_password'
    new_password = 'new_password'
    new_password_reconfirm = 'new_password2'
    db_user_password = 'password'


class PathContent:
    """路径相关常量类"""

    def __init__(self):
        pass

    login_page_path = 'user/login.html'
    register_page_path = 'user/register.html'
    search_user_page_path = 'search/search_user.html'
    setting_page_path = 'user/setting.html'
    my_ob_page_path = 'user/myob.html'
    detail_page_path = 'user/personaldetail.html'
    profile_page_path = 'user/profile.html'
    home_page_path = '/'
    login_url = '/userprofile/login/'


# 被前端调用 暂时不进行重构


def search_user(request):
    """根据前端获得的Search值对用户进行搜索"""
    # 判断是否进行了搜索
    search = request.GET.get('search')
    users = []
    # 如果进行了搜索
    if search:
        users = User.objects.filter(
            # 匹配用户名(不区分大小写)
            Q(username__icontains=search)
        )
    context = {'users': users, 'search_u': search}
    return render(request, PathContent.search_user_page_path, context)


def user_form(request, message_type, choose):
    """
    返回各种情况下需要返回的用户表单
    提取出的公共函数，方便其他函数进行返回
    """
    # 创建用户表单类
    if choose == Content.is_login:
        form = UserLoginForm()
    elif choose == Content.is_register:
        form = UserRegisterForm()
    else:
        form = UserLoginForm()
    # 赋予上下文
    context = {'form': form}
    if message_type == Content.is_need_message and choose == Content.is_login:
        messages.success(request, Content.login_error_message)
    elif message_type == Content.is_need_message and choose == Content.is_register:
        messages.success(request, Content.register_error_message)
    elif message_type == Content.is_dangerous_message:
        messages.success(request, Content.danger_message)
    else:
        pass
    if choose == Content.is_login:
        return render(request, PathContent.login_page_path, context)
    elif choose == Content.is_register:
        return render(request, PathContent.register_page_path, context)


# UserLogin Class


class UserLogin(TemplateView):
    """根据前端获得的用户登录表格信息，进行登录处理操作类（包含密码检查）"""
    template_name = PathContent.login_page_path

    def get(self, request, *args, **kwargs):
        return user_form(request, Content.not_need_message, Content.is_login)

    def post(self, request, *args, **kwargs):
        user_login_form = UserLoginForm(data=request.POST)
        # 判断数据是否有效
        if user_login_form.is_valid():
            # 清洗出合法数据
            data = user_login_form.cleaned_data
            # 检验账号、密码是否正确匹配数据库中的某个用户
            # 如果均匹配则返回这个 user 对象
            user = authenticate(username=data[Content.db_user_name], password=data[PasswordContent.db_user_password])
            if user:
                # 将用户数据保存在 session 中，即实现了登录动作
                login(request, user)
                # 返回主页链接
                return redirect(PathContent.home_page_path)
            else:
                return user_form(request, Content.is_need_message, Content.is_login)
        else:
            return user_form(request, Content.is_need_message, Content.is_login)


# 用户退出
def user_logout(request):
    """将已登录的用户执行登出操作"""
    # 用户登出
    logout(request)
    # 返回首页
    return redirect(PathContent.home_page_path)


def permissions():
    """赋予用户相关权限，方便创建用户，封禁用户时调用"""
    p1 = Permission.objects.get(codename='add_articlepost')
    p2 = Permission.objects.get(codename='change_articlepost')
    p3 = Permission.objects.get(codename='view_articlepost')
    p4 = Permission.objects.get(codename='add_questionpost')
    p5 = Permission.objects.get(codename='change_questionpost')
    p6 = Permission.objects.get(codename='view_questionpost')
    p7 = Permission.objects.get(codename='add_comment')
    p8 = Permission.objects.get(codename='change_comment')
    # 由于有重复字段，所以不能靠codename查询，用序号代替，所以如果新作数据迁移可能需要改这个地方
    # p9 = Permission.objects.get(codename = 'add_answer')
    # 序号重复，暂用其他权限名称
    # p9 = Permission.objects.get(id = 41)
    p9 = Permission.objects.get(codename='add_session')
    # p10 = Permission.objects.get(codename = 'change_answer')
    # p10 = Permission.objects.get(id = 42)
    p10 = Permission.objects.get(codename='change_session')
    p11 = Permission.objects.get(codename='change_collectcount')
    p12 = Permission.objects.get(codename='change_likecount')
    return [p1, p2, p3, p4, p5, p6, p7, p8, p9, p10, p11, p12]


class UserRegister(TemplateView):
    """根据前端获得的用户注册表格信息，进行注册录处理操作类（包含密码检查，用户权限授予"""

    def get(self, request, *args, **kwargs):
        return user_form(request, Content.not_need_message, Content.is_register)

    def post(self, request, *args, **kwargs):
        # 得到注册表单数据
        user_register_form = UserRegisterForm(data=request.POST)
        # 检测数据是否有效
        if user_register_form.is_valid():
            # 保存表单到暂存区
            new_user = user_register_form.save(commit=False)
            # 设置密码
            new_user.set_password(user_register_form.cleaned_data[PasswordContent.db_user_password])
            # 保存用户名密码到数据库
            new_user.save()
            # 保存好数据后立即登录
            login(request, new_user)
            # 赋予新用户权限
            new_user.user_permissions.set(permissions())
            # 返回主界面
            return redirect(PathContent.home_page_path)
        else:
            return user_form(request, Content.is_need_message, Content.is_register)


@login_required(login_url=PathContent.login_url)
def user_delete(request, id):
    """对已登录的用户进行删除操作"""
    # 得到用户id
    user = User.objects.get(id=id)
    # 验证登录用户、待删除用户是否相同
    if request.user == user:
        # 退出登录
        logout(request)
        # 删除数据
        user.delete()
        # 返回主界面
        return redirect(PathContent.home_page_path)
    else:
        return HttpResponse(Content.del_warn_message)


# 用户安全删除
@login_required(login_url=PathContent.login_url)
def user_safe_delete(request, id):
    # 判断是否是用户POST
    if request.method == Content.method_post:
        # 得到用户id
        user = User.objects.get(id=id)
        # 验证登录用户、待删除用户是否相同
        if request.user == user:
            # 退出登录
            logout(request)
            # 删除数据
            user.delete()
            # 返回主界面
            return redirect(PathContent.home_page_path)
        else:
            return HttpResponse(Content.del_warn_message)
    else:
        return HttpResponse(Content.danger_message)


@login_required(login_url=PathContent.login_url)
def profile(request, id):
    """查看用户个人信息界面，将个人信息返回至前端"""
    user = User.objects.get(id=id)
    if Profile.objects.filter(user_id=id).exists():
        profile = Profile.objects.get(user_id=id)
    else:
        profile = Profile.objects.create(user=user)

    context = {Content.profile: profile, Content.user: user}
    return render(request, PathContent.detail_page_path, context)


class ProfileUpdate(LoginRequiredMixin, TemplateView):
    """更新用户的个人信息类"""
    login_url = PathContent.login_url

    def get(self, request, *args, **kwargs):
        # class-based view html传递的参数是从kwargs的字典传递的
        id = kwargs[Content.id]
        user = User.objects.get(id=id)
        # user_id 是 OneToOneField 自动生成的字段
        if Profile.objects.filter(user_id=id).exists():
            profile = Profile.objects.get(user_id=id)
        else:
            profile = Profile.objects.create(user=user)
        profile_form = UserProfileForm()
        context = {Content.profile_form: profile_form, Content.profile: profile, Content.user: user}
        return render(request, PathContent.profile_page_path, context)

    def post(self, request, *args, **kwargs):
        id = kwargs[Content.id]
        print(id)
        user = User.objects.get(id=id)
        # user_id 是 OneToOneField 自动生成的字段
        if Profile.objects.filter(user_id=id).exists():
            profile = Profile.objects.get(user_id=id)
        else:
            profile = Profile.objects.create(user=user)
            # 验证修改数据者，是否为用户本人
        if request.user != user:
            return HttpResponse(Content.update_error_message)

        profile_form = UserProfileForm(request.POST, request.FILES)
        if profile_form.is_valid():
            # 取得清洗后的合法数据
            profile_cd = profile_form.cleaned_data
            profile.phone = profile_cd[Content.phone]

templates/user/collection.html
{% extends "base.html" %}
{% load staticfiles %}
{% load like_tags %}
{% load collect_tags %}

{% block title %}
    我的收藏
{% endblock title %}

{% block content %}
<div class="text-center mt-4">
    <h4><b>我的收藏</b></h4>
</div>

<div class="container">
        <div class="d-flex justify-content-center mt-4">
            <form class="form-inline" >

                <label for="search" class="mr-4">搜索</label>
                <input type="text"
                    class="form-control mb-2 mr-sm-2"
                       id="search"
                    name="search"
                    placeholder="搜索..."
                    required
                >
            </form>
        </div>
</div>
<div class="container ml-4">
	{% if search %}
        {% if collections %}
            <h4><span style="color: cadetblue">"{{ search }}"</span>的搜索结果如下：</h4>
            <hr>
        {% else %}
            <h4>暂无<span style="color: cadetblue">"{{ search }}"</span>有关的收藏。</h4>
            <hr>
        {% endif %}
	<HR>
	{% endif %}

	{% if len %}
	<p>收藏数：{{len}}</p>

	{% for collection in collections %}
	<HR>
	<div><!--回答1-->
		{% if collection.content_type == 'answer' or collection.content_type == 'comment'%}
			<span>
                    <i class="fas fa-user" style="color:yellowgreen"></i>
                    {{ collection.object.user }}
                </span>
		{% else %}
		<span>
                    <i class="fas fa-user" style="color:yellowgreen"></i>
                    {{ collection.object.author }}
                </span>
		{% endif %}


		{% if collection.content_type == 'articlepost' %}
        	<p><a href="{% url 'article:article_detail' collection.object.id %}">{{collection.object.title}}</a></p>
		{% elif collection.content_type == 'questionpost' %}
        	<p><a href="{% url 'question:question_detail' collection.object.id %}">{{collection.object.title}}</a></p>
		{% elif collection.content_type == 'answer' %}
			<p><a href="{% url 'question:question_detail' collection.object.question.id %}">回答：{{collection.object.body|slice:'100'}}</a></p>
		{% elif collection.content_type == 'comment' %}
			<p><a href="{% url 'article:article_detail' collection.object.article.id %}">评论：{{collection.object.body|slice:'100'}}</a></p>
		{% endif %}

		<p>
			<span class="mr-2"><i id="like-icon" class="fas fa-heart" style="color:pink;"></i>{% get_likes_num collection.object %}</span>
			<span class="mr-2"><i id="collect-icon" class="fas fa-paper-plane" style="color:cadetblue;"></i>{% get_collect_num collection.object %}</span>
			{% if collection.object.updated %}
			<span class="mr-2">
                    <i class="fas fa-clock" style="color:gray;"></i>
                    {{collection.object.updated|date:'Y-m-d' }}
                </span>
			{% else %}
			<span class="mr-2">
                    <i class="fas fa-clock" style="color:gray;"></i>
                    {{collection.object.created|date:'Y-m-d' }}
                </span>
			{% endif %}</p>
	</div>
	{% endfor %}
	{% else %}
	{% if not search %}
	<h5>还没有收藏哦，快去添加收藏吧~</h5>
	{% endif %}
	{% endif %}
</div>
{% endblock content %}

templates/user/login.html
{% extends "base.html" %}
{% load staticfiles %}
{% block title %} 登录 {% endblock title %}
{% block content %}
<div class="container">
        <div class="d-flex mt-5 justify-content-center">
            <br>
            <form method="post" action=".">
                {% csrf_token %}
                <!-- 账号 -->
                <div class="form-group">
                    <label for="username">账号</label>
                    <input type="text" class="form-control" id="username" name="username">
                </div>
                <!-- 密码 -->
                <div class="form-group">
                    <label for="password">密码</label>
                    <input type="password" class="form-control" id="password" name="password">
                </div>
                <!-- 提交按钮 -->
                <button type="submit" class="btn btn-primary">提交</button>
                <!-- 注册 -->
                <div class="col-12">
                    <br>
                    <h5>点击<a href='{% url "userprofile:register" %}'>注册</a></h5>
                    <br>
                </div>
            </form>
        </div>
</div>
{% if messages %}
        <script>
            {% for msg in messages %}
                alert('{{ msg.message }}');
            {% endfor %}
        </script>
{% endif %}
{% endblock content %}

templates/user/myob.html
<!-- extends表明此页面继承自 base.html 文件 -->
{% extends "base.html" %}
{% load static %}



<!-- 写入 base.html 中定义的 title -->
{% block title %}

{{ this_user.username }}的空间

{% endblock title %}

<!-- 写入 base.html 中定义的 content -->
{% block content %}
<div class="text-center mt-4">
    <h4><b>{{ this_user.username }}的空间</b></h4>
</div>

<!-- 定义放置文章标题的div容器 -->
<div class="container">


    <div class="row mt-2">

        {% for ob in column_content %}

        <!-- 文章内容 -->
        <div class="col-12">
            <!-- 栏目 -->
            {% if ob.column %}
                <button type="button"
                    class="btn btn-sm mb-2
                        {% if ob.column.title == '交友' %}
                            btn-success
                        {% elif ob.column.title == '学习' %}
                            btn-danger
                        {% elif ob.column.title == '生活' %}
                            btn-warning
                        {% endif %}
                    "
                >
                    {{ ob.column }}
                </button>
            {% endif %}

            <!-- 标题 -->
            <h4>
                <b>
                    {% if ob.type == 'question' %}
                    <a href="{% url 'question:question_detail' ob.id %}"
                       style="color: black;"
                    >
                        {{ ob.title }}
                    </a>
                    {% else %}
                    <a href="{% url 'article:article_detail' ob.id %}"
                       style="color: black;"
                    >
                        {{ ob.title }}
                    </a>
                    {% endif %}
                </b>
            </h4>
            <!-- 摘要 -->
            <div>
                <p style="color: gray;">
                    {{ ob.body|slice:'100' }}...
                </p>
            </div>
            <!-- 注脚 -->
            <p>
                <!-- 附加信息 -->

                <span>
                    <i class="fas fa-clock" style="color:pink;"></i>
                    {{ ob.updated|date:'Y-m-d' }}
                </span>
                <span>
                    <i class="fa fa-battery-full" aria-hidden="true"></i>
                    {{ ob.type }}
                </span>
            </p>
        </div>
        <hr style="width: 100%;"/>

        {% endfor %}

    </div>
  <!-- 页码导航 -->
    <div class="pagination row">
        <div class="m-auto">
            <span class="step-links">
                <!-- 如果不是第一页，则显示上翻按钮 -->
                {% if column_content.has_previous %}
                    <a href="?page=1" class="btn btn-success">
                        &laquo; 1
                    </a>
                    <span>...</span>
                    <a href="?page={{ column_content.previous_page_number }}" class="btn btn-secondary">
                        {{ column_content.previous_page_number }}
                    </a>
                {% endif %}

                <!-- 当前页面 -->
                <span class="current btn btn-danger btn-lg">
                    {{ column_content.number }}
                </span>

                <!-- 如果不是最末页，则显示下翻按钮 -->
                {% if column_content.has_next %}
                    <a href="?page={{ column_content.next_page_number }}" class="btn btn-secondary">
                        {{ column_content.next_page_number }}
                    </a>
                    <span>...</span>
                    <a href="?page={{ column_content.paginator.num_pages }}"class="btn btn-success">
                        {{ column_content.paginator.num_pages }} &raquo;
                    </a>
                {% endif %}
            </span>
        </div>
    </div>

</div>

</div>
{% endblock content %}

templates/user/personaldetail.html
{% extends "base.html" %} {% load staticfiles %}
{% block title %} 用户信息 {% endblock title %}
{% block content %}
<br>
<br>

<div class="container-fluid">
	<div class="row ">
		<!--分成两份2-10-->
		<div class="col-md-2 col-sm-2">
			<!--第一个列，2/12，中间嵌套一个行，-->
			<div class="row">
				<div class="col-md-8 col-sm-8">
					<ul class="nav nav-sidebar">
						<li><button type="button" class="btn btn-light"><a href="{% url 'userprofile:profile_update' user.id %}">更改个人信息</a></button></li>
						<li><button type="button" class="btn btn-light"><a href="{% url 'userprofile:password_update' user.id %}">修改个人密码</a></button></li>
					</ul>
                </div>
            </div>   
		</div>
	</div>
</div>
<div class="container">
    <div class="row">
        <div class="col-12">
		<!--之后添加头像部分-->
		<div class="offset-2">
			{% if profile.avatar %}
			<div class="col-md-4">头像</div>
			<img src="{{ profile.avatar.url }}" style="max-width: 20%; border-radius: 15%; object-fit: cover;" class="col-md-4">
			{% else %}
			<h5 class="col-md-4">暂无头像</h5>
			{% endif %}
			<div style="color:gray" class="col-md-4">我的用户名:   {{ user.username }}</div>
 			<div style="color:gray" class="col-md-4">电话:   {{ profile.phone }}</div>
			
			<div style="color:gray" class="col-md-4">我的邮箱:
                {% if user.email %}
					{{  user.email }}
                {% else %}
					None
				{% endif %}
			</div>
			<div style="color:gray" class="col-md-4">简介:   {{ profile.bio }} </div>
		</div>
	</div>
</div>
</div>
</div>
{% if messages %}
<!--信息弹框形式-->
<script>
    {% for msg in messages %}
        alert('{{ msg.message }}');
    {% endfor %}
</script>
{% endif %}


{% endblock content %}